﻿using ValidationEngine.Commons.Enums;
using ValidationEngine.Commons.Interfaces;
namespace ValidationEngine.Commons
{
    /// <summary>
    /// Provides information about model instance, property to validate and appling context
    /// </summary>
    public class ValidationContext : IValidationContext
    {
        /// <summary>
        /// Model instance
        /// </summary>
        public IValidateableModel Model { get; set; }
        /// <summary>
        /// Model's property to validate
        /// </summary>
        public string PropertyName { get; set; }
        /// <summary>
        /// Appling context
        /// </summary>
        public RuleApplingContext ApplingContext { get; set; }
    }
}
