﻿using System;
namespace ValidationEngine.Tools
{
    /// <summary>
    /// Extended ErrorProvider interface
    /// </summary>
    interface IXErrorProvider
    {
        /// <summary>
        /// Clears control validation info
        /// </summary>
        /// <param name="ctrl">Control</param>
        void Clear(System.Windows.Forms.Control ctrl);
        /// <summary>
        /// Sets error for control
        /// </summary>
        /// <param name="ctrl">Control</param>
        /// <param name="text">Error text</param>
        void SetError(System.Windows.Forms.Control ctrl, string text);
        /// <summary>
        /// Sets info for control
        /// </summary>
        /// <param name="ctrl">Control</param>
        /// <param name="text">Info text</param>
        void SetInfo(System.Windows.Forms.Control ctrl, string text);
        /// <summary>
        /// Sets warning for control
        /// </summary>
        /// <param name="ctrl">Control</param>
        /// <param name="text">Warning text</param>
        void SetWarning(System.Windows.Forms.Control ctrl, string text);
    }
}
