﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using ValidationEngine.Commons.Interfaces;

namespace ValidationEngine.Commons
{
    /// <summary>
    /// Event arguments for PropertyValidationg event
    /// </summary>
    public class PropertyValidationEventArgs : EventArgs
    {
        public IValidationContext Context { get; set; }
        public IValidationInfo ValidationInfo { get; set; }

        public PropertyValidationEventArgs()
        {
            this.Context = new ValidationContext();
            this.ValidationInfo = new ValidationInfo();
        }
    }

    /// <summary>
    /// PropertyValidating event handler delegate
    /// </summary>
    /// <param name="e"></param>
    public delegate void PropertyValidationEventHandler(PropertyValidationEventArgs e);
}
