﻿using System;
using ValidationEngine.Commons;
using ValidationEngine.Commons.Enums;
using ValidationEngine.Commons.Interfaces;
using ValidationEngine.Tools;

namespace ValidationEngine.ValidationRules
{
    public class MaxLengthRule : BaseValidationRule
    {
        #region Members
        private decimal _maxLength; 
        #endregion

        protected override IValidationInfo ApplyRule(IValidationContext ctx)
        {
            DefResult = ModelHelper.GetPropertyValue(ctx).ToString().Length > _maxLength ? _defErrorMsg : null;
            return Result;
        }

        #region Ctor
        public MaxLengthRule(
         decimal maxLength,
         string defErrorText = null,
         RuleApplingContext ruleApplingContext = RuleApplingContext.Always,
         ValidationErrorType errorType = ValidationErrorType.Error)
        {
            this._maxLength = maxLength;
            this.ApplingContext = ruleApplingContext;
            this._defErrorType = errorType;
            this._defErrorMsg = defErrorText ?? String.Format("Max length should be: {0}.", maxLength);
        } 
        #endregion
    }
}
